## ixo-usb-jtag 0.0.1

=== Makefile ===
#-----------------------------------------------------------------------------
# Makefile for usb_jtag FX2 firmware
#-----------------------------------------------------------------------------
# Copyright 2007 Kolja Waschk, ixo.de
# Copyright (C) 2017 Alexandru Gagniuc <mr.nuke.me@gmail.com>
#-----------------------------------------------------------------------------
# This code is part of usbjtag. usbjtag is free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version. usbjtag is distributed in the hope
# that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.  You should have received a
# copy of the GNU General Public License along with this program in the file
# COPYING; if not, write to the Free Software Foundation, Inc., 51 Franklin
# St, Fifth Floor, Boston, MA  02110-1301  USA
#-----------------------------------------------------------------------------

LIBDIR=fx2
LIB=libfx2.lib

SHELL := /bin/bash

# Specify a list of targets to build. Each target requires a hw_$target.c file
# to be present, and will produce a usbjtag-$target.hex output file.
TARGETS=basic dj_usb saxo_l xpcu_i xpcu_x nexys opsis

HEX_OUTPUTS=$(TARGETS:%=usbjtag-%.hex)

# Some distros add a prefix to sdcc binaries. For example, in fedora the
# binary is 'sdcc-sdcc'. Allow specifying this prefix via SDCC_PREFIX.
# Usage example: $ make SDCC_PREFIX=sdcc-
SDCC_PREFIX ?=

CC = $(SDCC_PREFIX)sdcc
AS = $(SDCC_PREFIX)sdas8051
AR = $(SDCC_PREFIX)sdcclib
PACKIHX=$(SDCC_PREFIX)packihx

CFLAGS+=-mmcs51 --no-xinit-opt -I${LIBDIR}

ASFLAGS+=-plosgff

LDFLAGS=--code-loc 0x0000 --code-size 0x1800
LDFLAGS+=--xram-loc 0x1800 --xram-size 0x0800
LDFLAGS+=-Wl '-b USBDESCSEG = 0xE100'
LDFLAGS+=-L ${LIBDIR}

%.rel : %.a51
	$(AS) $(ASFLAGS) $<

%.rel : %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $@

default: $(HEX_OUTPUTS)

dscr_%.a51: dscr.a51.in
	export H="hw_$*~~~~~~~~~"; cat $^ | \
	 sed \
          -e"s/\$$H0/$${H:0:1}/" \
          -e"s/\$$H1/$${H:1:1}/" \
          -e"s/\$$H2/$${H:2:1}/" \
          -e"s/\$$H3/$${H:3:1}/" \
          -e"s/\$$H4/$${H:4:1}/" \
          -e"s/\$$H5/$${H:5:1}/" \
          -e"s/\$$H6/$${H:6:1}/" \
          -e"s/\$$H7/$${H:7:1}/" \
          -e"s/\$$H8/$${H:8:1}/" \
          -e"s/\$$H9/$${H:9:1}/" | \
	 sed \
	  -e"s/        .db        '~, 0//" \
	 > $@

#%.iic : %.hex
#	./hex2bix -ir -f 0xC2 -m 0xF000 -c 0x1 -o $@ $<
%.bix: %.hex
	objcopy -I ihex -O binary $< $@

temp-%.hex: vectors.rel usbjtag.rel dscr_%.rel eeprom.rel hw_%.rel startup.rel ${LIBDIR}/${LIB}
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $+

usbjtag-%.hex: temp-%.hex
	$(PACKIHX) $^ > $@
	ls -al $@

${LIBDIR}/${LIB}:
	make -C ${LIBDIR} CC=$(CC) AR=$(AR)

.PHONY: boot
boot: std.hex
	-test -e /dev/usb_jtag    && /sbin/fxload -D /dev/usb_jtag    -I std.hex -t fx2
	-test -e /dev/tracii_xl2  && /sbin/fxload -D /dev/tracii_xl2  -I std.hex -t fx2
	-test -e /dev/xilinx_xpcu && /sbin/fxload -D /dev/xilinx_xpcu -I std.hex -t fx2

REF=/home/kawk/work/xilinx/xtern/xusbdfwu/xusbdfwu-1025.hex

.PHONY: ref
ref: 
	-test -e /dev/usb_jtag    && /sbin/fxload -D /dev/usb_jtag    -I ${REF} -t fx2
	-test -e /dev/tracii_xl2  && /sbin/fxload -D /dev/tracii_xl2  -I ${REF} -t fx2
	-test -e /dev/xilinx_xpcu && /sbin/fxload -D /dev/xilinx_xpcu -I ${REF} -t fx2

dscr_%.rel: dscr_%.a51
eeprom.rel: eeprom.c eeprom.h
usbjtag.rel: usbjtag.c hardware.h eeprom.h
hw_%.rel: hw_%.c hardware.h

.PHONY: clean distclean

clean:
	make -C ${LIBDIR} clean
	rm -f *.lst *.asm *.lib *.sym *.rel *.mem *.map *.rst *.lnk *.lk *.hex dscr_%.a51

distclean: clean

=== fx2/Makefile ===
#-----------------------------------------------------------------------------
# Makefile for FX2 library code
#-----------------------------------------------------------------------------
# Copyright (C) 2007 Kolja Waschk, ixo.de
#-----------------------------------------------------------------------------
# This code is part of usbjtag. usbjtag is free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version. usbjtag is distributed in the hope
# that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.  You should have received a
# copy of the GNU General Public License along with this program in the file
# COPYING; if not, write to the Free Software Foundation, Inc., 51 Franklin
# St, Fifth Floor, Boston, MA  02110-1301  USA
#-----------------------------------------------------------------------------

CC=sdcc
CFLAGS+=-mmcs51 --no-xinit-opt -I.
CPPFLAGS+=
OBJS=delay.rel fx2utils.rel i2c.rel isr.rel timer.rel usb_common.rel
AR=sdcclib

(%.rel) : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $*.rel
	$(AR) -a $@ $*.rel
	rm $*.rel

libfx2.lib: libfx2.lib($(OBJS))

clean:
	rm -f *.lst *.asm *.lib *.sym *.rel *.lib

## ixo-usb-jtag 0.0.0+git20160908

=== debian/changelog ===
ixo-usb-jtag (0.0.0+git20160908-1) unstable; urgency=low

  * Initial upload. (Closes: #846185)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 28 Nov 2016 23:35:58 -0800

=== debian/control ===
Source: ixo-usb-jtag
Maintainer: Stefano Rivera <stefanor@debian.org>
Section: embedded
Priority: optional
Build-Depends: debhelper (>= 9), sdcc
Standards-Version: 3.9.8
Homepage: https://github.com/mithro/ixo-usb-jtag
Vcs-Git: https://anonscm.debian.org/git/collab-maint/ixo-usb-jtag.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/ixo-usb-jtag.git

Package: ixo-usb-jtag
Architecture: all
Depends: ${misc:Depends}
Suggests: fxload
Description: Firmware for USB JTAG programmers
 This firmware allows a USB-capable microcontroller to act like an Altera
 USB-Blaster JTAG pod. Which in turn may allow you to use tools you'd normally
 use with the Altera USB-Blaster, including UrJTAG and openocd.
 .
 Supported hardware: The Cypress FX2 EZ-USB family, or an FTDI FT245 in
 combination with a CPLD. Builds are included for the hdmi2usb project's boards
 (Digilet Atlys and Numato Opsis).

=== debian/rules ===
#!/usr/bin/make -f

HARDWARE=hw_basic hw_saxo_l hw_xpcu_i hw_xpcu_x hw_nexys hw_opsis

%:
	dh $@

override_dh_auto_build:
	mkdir -p output
	set -e; \
		for HW in $(HARDWARE); do \
			make clean; \
			make HARDWARE=$$HW; \
			cp usbjtag.hex output/$$HW.hex; \
		done

VER=$(shell dpkg-parsechangelog | sed -rne 's/^Version: (.+)-.*/\1/p')
get-packaged-orig-source:
	git clone https://github.com/mithro/ixo-usb-jtag
	set -xe; \
		GIT_DATE=$$(dpkg-parsechangelog | sed -rne 's/^Version: .*\+git(....)(..)(..)-.*/\1-\2-\3 00:00:00 UTC/p'); \
		cd ixo-usb-jtag; \
		GIT_COMMIT=$$(git rev-list -n1 --until="$$GIT_DATE" master); \
		git archive $$GIT_COMMIT --prefix=ixo-usb-jtag_$(VER).orig/ -o ../ixo-usb-jtag_$(VER).orig.tar
	xz -f ixo-usb-jtag_$(VER).orig.tar
	rm -rf ixo-usb-jtag

## ixo-usb-jtag 0.0.1

=== debian/changelog ===
ixo-usb-jtag (0.0.1-2) unstable; urgency=medium

  * Migrate from sdcclib to sdar, fixing FTBFS with sdcc 3.9.
    (Closes: #963389)
  * Bump copyright years.
  * Bump debhelper compat level to 12.
  * Declare Rules-Requires-Root: no.
  * Bump Standards-Version to 4.5.0, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 27 Jun 2020 16:28:50 -0700

ixo-usb-jtag (0.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright.
  * Migrate to salsa.debian.org.
  * Use upstream build system, it now supports building multiple targets.
  * Add compatibility symlinks for the files hdmi2usb-mode-switch expects.
  * Bump Standards-Version to 4.1.3, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 16 Jan 2018 12:27:16 +1100

=== debian/control ===
Source: ixo-usb-jtag
Maintainer: Stefano Rivera <stefanor@debian.org>
Section: embedded
Priority: optional
Build-Depends: debhelper-compat (= 12), sdcc
Standards-Version: 4.5.0
Homepage: https://github.com/mithro/ixo-usb-jtag
Vcs-Git: https://salsa.debian.org/debian/ixo-usb-jtag.git
Vcs-Browser: https://salsa.debian.org/debian/ixo-usb-jtag
Rules-Requires-Root: no

Package: ixo-usb-jtag
Architecture: all
Depends: ${misc:Depends}
Suggests: fxload
Description: Altera Bus Blaster emulation using Cypress FX2 chip
 This firmware allows a USB-capable microcontroller to act like an Altera
 USB-Blaster JTAG pod. Which in turn may allow you to use tools you'd normally
 use with the Altera USB-Blaster, including UrJTAG and openocd.
 .
 Supported hardware: The Cypress FX2 EZ-USB family, or an FTDI FT245 in
 combination with a CPLD. Builds are included for the hdmi2usb project's boards
 (Digilet Nexys, Nexys2, Atlys and Numato Opsis).

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,7 @@
 #!/usr/bin/make -f
-
-HARDWARE=hw_basic hw_saxo_l hw_xpcu_i hw_xpcu_x hw_nexys hw_opsis
 
 %:
 	dh $@
-
-override_dh_auto_build:
-	mkdir -p output
-	set -e; \
-		for HW in $(HARDWARE); do \
-			make clean; \
-			make HARDWARE=$$HW; \
-			cp usbjtag.hex output/$$HW.hex; \
-		done
 
 VER=$(shell dpkg-parsechangelog | sed -rne 's/^Version: (.+)-.*/\1/p')
 get-packaged-orig-source:

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ixo-usb-jtag-$1.tar.gz%" \
 https://github.com/mithro/ixo-usb-jtag/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
